import es
import cPickle
import os
import popuplib
import random
import base64


gamedir = str(es.ServerVar("eventscripts_gamedir"))

####################################
			#Config Block

#Set here the soundfolder (all sounds from this folder will be used as possible joinsounds)
sounddir = "myfolder/joinsounds"


#Send ever round a message? 1 = On, 0 = Off
adver_message = 1


			#End Config Block
####################################
info = es.AddonInfo()
info.author = "Brainsucker"
info.version = "1.1.0"
info.name = "JoinSound"

play_sounds = filter(lambda temp: temp.endswith(".mp3") or temp.endswith(".wav"), os.listdir(gamedir + "/sound/" + sounddir))
logfile = es.getAddonPath("joinsound") + "/soundlog.db"


def spopup_choice(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	if choice == "view_sounds":
		popuplib.send("soundlistpopup", userid)
	elif choice == "random_sound":
		del sounds[steamid]
		es.tell(userid, "#multi", "You will now have random joinsound!")
	else:
		if not sounds.has_key(steamid):
			sounds[steamid] = {}
		sounds[steamid]["favsound"] = choice
		popuplib.send("soundpopup2", userid)
		es.tell(userid, "#multi", "#defaultYour new Joinound will be #lightgreen%s" % choice)
	
def slistpopup_choice(userid, choice, popupid):
	popuplib.send("soundlistpopup", userid)
	es.cexec(userid, "play %s" % choice)
	
def downloadfiles():
	for download in play_sounds:
		es.stringtable('downloadables', 'sound/%s/%s' % (sounddir, download))

def load():
	global sounds
	soundcounter = 0
	if info.author == base64.decodestring("QnJhaW5zdWNrZXI=\n"):
		es.ServerVar(info.name, info.version).makepublic()
		sounds = {}
		try:
			sounds = cPickle.load(open(logfile, "rb"))
		except:
			pass
		
		downloadfiles()
		
		spopup = popuplib.easymenu("soundpopup2", "_popup_choice", spopup_choice)
		spopup.settitle("Choose your favourite Sound")
		spopup.addoption("view_sounds", "Show me Soundlist")
		spopup.addoption("random_sound", "Random Sound")
		
		slistpopup = popuplib.easymenu("soundlistpopup", "_popup_choice", slistpopup_choice)
		slistpopup.settitle("Choose a Number to play the Sound")
		
		for line in play_sounds:
			soundcounter += 1
			spopup.addoption(sounddir + "/" + line, "Sound %i" % soundcounter)
			slistpopup.addoption(sounddir + "/" + line, "Sound %i" % soundcounter)
		
def player_activate(ev):
	steamid = ev["es_steamid"]
	userid = ev["userid"]
	if not steamid in ["STEAM_ID_PENDING", "BOT"]:
		rand_sound = sounddir + "/" + random.choice(play_sounds)
		if sounds.has_key(steamid):
			es.cexec(userid, "play %s" % sounds[steamid]["favsound"])
		else:
			es.cexec(userid, "play %s" % rand_sound)

def round_end(ev):
	cPickle.dump(sounds, open(logfile, "wb"))

def es_map_start(ev):
	downloadfiles()

def player_say(ev):
	if ev["text"].lower() == "!soundsettings":
		popuplib.send("soundpopup2", ev["userid"])


def round_start(ev):
	if advert_message:
		es.msg("#multi", "Write #green!soundsettings #defaultto choose your favourite Joinsound")
	
def unload():	
	if popuplib.exists("soundlistpopup"):
		popuplib.delete("soundlistpopup")
		
	if popuplib.exists("soundpopup2"):
		popuplib.delete("soundpopup2")